"use strict";
//  Copyright PrimeObjects Software Inc. and other contributors <https://www.primeobjects.com/>
//
//  This source code is licensed under the MIT license.
//  The detail information can be found in the LICENSE file in the root directory of this source tree.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeaderMenuTitle = void 0;
var react_1 = __importStar(require("react"));
var svg_1 = __importDefault(require("../svg"));
var react_2 = require("@headlessui/react");
var lodash_1 = require("lodash");
var menu_actions_1 = __importDefault(require("./menu-actions"));
var menu_items_1 = __importDefault(require("./menu-items"));
var menu_posts_1 = __importDefault(require("./menu-posts"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var link_1 = __importDefault(require("next/link"));
var HeaderMenuTitle = function (props) {
    var title = (0, primeobjects_helper_util_1.isNonEmptyString)(props.title) ? props.title : "Need Title";
    var colorName = (0, primeobjects_helper_util_1.isNonEmptyString)(props.colorName) ? props.colorName : "sky";
    var href = (0, primeobjects_helper_util_1.isNonEmptyString)(props.href) ? props.href : "#";
    var maxWidth = (0, lodash_1.isNumber)(props.maxWidth) && props.maxWidth > 100 ? props.maxWidth : 400;
    var sections = (0, lodash_1.isArray)(props.sections) ? props.sections : [];
    var renderSections = function () {
        return (0, lodash_1.without)((0, lodash_1.map)(sections, function (section, idx) {
            switch (section.type) {
                case "items":
                    return ((0, lodash_1.isArray)(section.data) && (react_1.default.createElement(menu_items_1.default, { key: "".concat(idx), title: section.title, href: section.href, mobileView: section.mobileView, data: section.data, colorName: colorName })));
                case "actions":
                    return (0, lodash_1.isArray)(section.data) && react_1.default.createElement(menu_actions_1.default, { key: "".concat(idx), title: section.title, data: section.data });
                case "posts":
                    return (0, lodash_1.isArray)(section.data) && react_1.default.createElement(menu_posts_1.default, __assign({ key: idx }, section));
                default:
                    return undefined;
            }
        }), undefined);
    };
    return !((0, lodash_1.isArray)(sections) && sections.length > 0) ? (react_1.default.createElement(link_1.default, { href: href },
        react_1.default.createElement("a", { className: "text-base text-gray-600 hover:text-gray-900" },
            react_1.default.createElement("span", null, title)))) : (react_1.default.createElement(react_2.Popover, { className: "relative" }, function (_a) {
        var open = _a.open;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(react_2.Popover.Button, { className: [
                    "group bg-white rounded-md inline-flex items-center content-center text-base focus:outline-none",
                    open ? "text-".concat(colorName, "-600 hover:text-").concat(colorName, "-500") : "text-gray-600 hover:text-gray-900"
                ].join(" ") },
                react_1.default.createElement("span", null, title),
                react_1.default.createElement(svg_1.default, { style: { width: 12, marginLeft: 10 }, src: "/icons/platform/chevron-down-menu.svg", color: open ? primeobjects_helper_util_1.COLORS[colorName.toUpperCase()]["700"] : primeobjects_helper_util_1.COLORS.GRAY["700"], className: open ? "flip-h" : "", "aria-hidden": "true" })),
            react_1.default.createElement(react_2.Transition, { as: react_1.Fragment, enter: "transition ease-out duration-200", enterFrom: "opacity-0 translate-y-1", enterTo: "opacity-100 translate-y-0", leave: "transition ease-in duration-150", leaveFrom: "opacity-100 translate-y-0", leaveTo: "opacity-0 translate-y-1" },
                react_1.default.createElement(react_2.Popover.Panel, { className: "absolute -ml-4 mt-3 transform z-10 px-2 w-screen max-w-screen-xs sm:px-0 lg:ml-0 lg:left-1/2 lg:-translate-x-1/2", style: { maxWidth: maxWidth } },
                    react_1.default.createElement("div", { className: "rounded-lg shadow-lg ring-1 ring-black ring-opacity-5 overflow-hidden" }, renderSections())))));
    }));
};
exports.HeaderMenuTitle = HeaderMenuTitle;
exports.default = exports.HeaderMenuTitle;
