"use strict";
//  Copyright PrimeObjects Software Inc. and other contributors <https://www.primeobjects.com/>
// 
//  This source code is licensed under the MIT license.
//  The detail information can be found in the LICENSE file in the root directory of this source tree.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeaderNotification = void 0;
var react_1 = __importDefault(require("react"));
var lodash_1 = require("lodash");
var svg_1 = __importDefault(require("../svg"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var styles = {
    countWrapper: { position: 'absolute', top: -6, right: -8, borderRadius: 9, backgroundColor: primeobjects_helper_util_1.COLORS.RED['800'], justifyContent: 'space-around' },
    count: { fontSize: 8, color: primeobjects_helper_util_1.COLORS.WHITE, alignSelf: 'center' }
};
var HeaderNotification = function (props) {
    var countWrapperStyle = props.countWrapperStyle, countStyle = props.countStyle, hide = props.hide, count = props.count, wrapperClassName = props.wrapperClassName, wrapperStyle = props.wrapperStyle;
    var size = (0, lodash_1.isInteger)(props.size) ? props.size : 24;
    return hide ? null : react_1.default.createElement("div", { style: wrapperStyle, className: "relative inline-flex ".concat((0, primeobjects_helper_util_1.isNonEmptyString)(wrapperClassName) ? wrapperClassName : '') },
        react_1.default.createElement("div", { className: "-mx-1 bg-white p-1 rounded-full text-gray-400 hover:text-gray-500" },
            react_1.default.createElement("span", { className: "sr-only" }, "View notifications"),
            react_1.default.createElement(svg_1.default, { size: size, color: primeobjects_helper_util_1.COLORS.GRAY['800'], src: "/icons/platform/notification.svg" }),
            (0, lodash_1.isNumber)(count) && count > 0 &&
                react_1.default.createElement("div", { className: "flex flex-row justify-center w-full", style: __assign(__assign({ width: size * 2 / 3, height: size * 2 / 3 }, styles.countWrapper), countWrapperStyle) },
                    react_1.default.createElement("div", { style: __assign(__assign({}, styles.count), countStyle) }, count > 9 ? '9+' : count))));
};
exports.HeaderNotification = HeaderNotification;
exports.default = exports.HeaderNotification;
