"use strict";
//  Copyright PrimeObjects Software Inc. and other contributors <https://www.primeobjects.com/>
// 
//  This source code is licensed under the MIT license.
//  The detail information can be found in the LICENSE file in the root directory of this source tree.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Logo = void 0;
var react_1 = __importDefault(require("react"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var lodash_1 = require("lodash");
var svg_1 = __importDefault(require("./svg"));
var Logo = function (props) {
    var color = props.color, id = props.id, text = props.text;
    var logoSize = (0, lodash_1.isNumber)(props.logoSize) && props.logoSize > 0 ? props.logoSize : 40;
    var logoSrc = (0, core_1.isNonEmptyString)(props.logoSrc) ? props.logoSrc : '/logo.svg';
    var wrapperClassName = (0, core_1.isNonEmptyString)(props.wrapperClassName) ? props.wrapperClassName : '';
    var className = (0, core_1.isNonEmptyString)(props.className) ? props.className : '';
    var textClassName = (0, core_1.isNonEmptyString)(props.textClassName) ? props.textClassName : '';
    var logoStyle = (0, core_1.isObject)(props.logoStyle) ? props.logoStyle : {};
    var textStyle = __assign({ marginLeft: 10, marginRight: 10, alignSelf: 'center', color: color, fontSize: '1.2rem', fontWeight: 700 }, props.textStyle);
    var onClick = function () {
        if ((0, lodash_1.isFunction)(props.onClick))
            props.onClick();
    };
    return react_1.default.createElement("div", { className: "flex justify-start ".concat(wrapperClassName) },
        react_1.default.createElement("div", { className: "flex flex-row ".concat(className), style: (0, lodash_1.isFunction)(props.onClick) ? { cursor: 'pointer' } : {}, onClick: onClick },
            logoSrc.indexOf('.svg') > 0 ?
                react_1.default.createElement(svg_1.default, { id: id, src: logoSrc, color: color, size: logoSize, style: __assign({}, logoStyle) }) :
                react_1.default.createElement("img", { id: id, src: logoSrc, style: __assign({ width: logoSize }, logoStyle) }),
            (0, core_1.isNonEmptyString)(text) && react_1.default.createElement("span", { style: textStyle, className: (0, core_1.isNonEmptyString)(textClassName) ? textClassName : '' }, text)));
};
exports.Logo = Logo;
exports.default = exports.Logo;
