"use strict";
//  Copyright PrimeObjects Software Inc. and other contributors <https://www.primeobjects.com/>
//
//  This source code is licensed under the MIT license.
//  The detail information can be found in the LICENSE file in the root directory of this source tree.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Resizer = void 0;
var react_1 = __importStar(require("react"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var lodash_1 = require("lodash");
var Resizer = function (props) {
    var className = (0, core_1.isNonEmptyString)(props.className) ? props.className : "";
    var style = (0, core_1.isObject)(props.style) ? props.style : {};
    var _a = (0, react_1.useState)({ x: 0, y: 0 }), pos = _a[0], setPos = _a[1];
    var _b = (0, react_1.useState)({ width: 100, height: 100 }), size = _b[0], setSize = _b[1];
    var r = (0, react_1.useRef)(null);
    var initial = function (e) {
        setPos({ x: e.clientX, y: e.clientY });
        setSize({ width: r.current.offsetWidth, height: r.current.offsetHeight });
    };
    var onResize = function (e, type) {
        var width = size.width + e.clientX - pos.x;
        var height = size.height + e.clientY - pos.y;
        switch (type) {
            case "width": {
                r.current.style.width = "".concat(width, "px");
                if ((0, lodash_1.isFunction)(props.onResize))
                    props.onResize(width, size.height);
                break;
            }
            case "height": {
                r.current.style.height = "".concat(height, "px");
                if ((0, lodash_1.isFunction)(props.onResize))
                    props.onResize(size.width, height);
                break;
            }
            default: {
                r.current.style.width = "".concat(width, "px");
                r.current.style.height = "".concat(height, "px");
                if ((0, lodash_1.isFunction)(props.onResize))
                    props.onResize(width, height);
                break;
            }
        }
        e.stopPropagation();
        e.preventDefault();
    };
    return (react_1.default.createElement("div", { className: "relative overflow-none ".concat(className), style: __assign({ width: "fit-content", height: "fit-content" }, style) },
        react_1.default.createElement("div", { ref: r, style: __assign({ minWidth: "100%", minHeight: "100%", width: "fit-content", height: "fit-content" }, style) }, props.children),
        react_1.default.createElement("div", { className: "absolute bg-red-600 resizer-handler", style: { cursor: "col-resize", width: 3, top: 3, right: 0, height: "calc(100% - 6px)", resize: "horizontal", background: "transparent" }, draggable: "true", onDragStart: initial, onDrag: function (e) { return onResize(e, "width"); } }),
        react_1.default.createElement("div", { className: "absolute bg-blue-600 resizer-handler", style: { cursor: "row-resize", height: 3, bottom: 0, left: 3, width: "calc(100% - 6px)", resize: "vertical", background: "transparent" }, draggable: "true", onDragStart: initial, onDrag: function (e) { return onResize(e, "height"); } }),
        react_1.default.createElement("div", { className: "absolute bg-black resizer-handler", style: { cursor: "se-resize", width: 3, height: 3, bottom: 0, right: 0, background: "transparent" }, draggable: "true", onDragStart: initial, onDrag: function (e) { return onResize(e, "both"); } })));
};
exports.Resizer = Resizer;
exports.default = exports.Resizer;
