import React, { useEffect, useState } from "react";
import { isInteger, isNil } from "lodash";
import { isNonEmptyString } from "primeobjects-helper-util/build/cjs/core";
import { useResizeDetector } from "react-resize-detector";
export var GradientDiv = function (props) {
    var content = props.content;
    var _a = useResizeDetector(), width = _a.width, height = _a.height, ref = _a.ref;
    var _b = useState(false), isOverflowX = _b[0], setIsOverflowX = _b[1];
    var className = isNonEmptyString(props.className) ? props.className : "";
    var gradientAreaWidth = !isNil(props.gradientAreaWidth) && isInteger(props.gradientAreaWidth) && props.gradientAreaWidth > 20 ? props.gradientAreaWidth : !isNil(width) ? width : "20%";
    useEffect(function () {
        setIsOverflowX(ref.current.scrollWidth - ref.current.clientWidth > 0);
    }, [width]);
    return (React.createElement("div", { ref: ref, className: "relative whitespace-nowrap overflow-hidden overflow-y-auto ".concat(className), title: content },
        content,
        isOverflowX && (React.createElement("div", { className: "absolute", style: {
                height: height,
                top: 0,
                right: 0,
                width: gradientAreaWidth,
                background: "linear-gradient(90deg, rgba(255,255,255,0) 0%, rgba(255,255,255,0.25) 25%, rgba(255,255,255,0.5) 50%, rgba(255,255,255,0.75) 75%, #ffffff)"
            } }))));
};
export default GradientDiv;
