//  Copyright PrimeObjects Software Inc. and other contributors <https://www.primeobjects.com/>
// 
//  This source code is licensed under the MIT license.
//  The detail information can be found in the LICENSE file in the root directory of this source tree.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { isInteger, isNil } from 'lodash';
import { SVG } from './svg';
import { isNonEmptyString } from 'primeobjects-helper-util/build/cjs/core';
import { GRAY, RED } from 'primeobjects-helper-util/build/cjs/colors';
var styles = {
    countWrapper: { top: -6, right: -8, borderRadius: 9, justifyContent: 'space-around' },
    count: { fontSize: 8, alignSelf: 'center' }
};
export var IconCount = function (props) {
    var countWrapperStyle = props.countWrapperStyle, countStyle = props.countStyle, wrapperClassName = props.wrapperClassName, wrapperStyle = props.wrapperStyle;
    var iconSize = !isNil(props.iconSize) && isInteger(props.iconSize) ? props.iconSize : 24;
    var iconColor = isNonEmptyString(props.iconColor) ? props.iconColor : GRAY['700'];
    var count = !isNil(props.count) && isInteger(props.count) ? props.count : 0;
    var countBackgroundColor = !isNil(props.countBackgroundColor) && isNonEmptyString(props.countBackgroundColor) ? props.countBackgroundColor : RED["600"];
    var countColor = !isNil(props.countColor) && isNonEmptyString(props.countColor) ? props.countColor : '#ffffff';
    return React.createElement("div", { style: wrapperStyle, className: "relative inline-flex ".concat(isNonEmptyString(wrapperClassName) ? wrapperClassName : '') },
        React.createElement("div", { className: "-mx-1 bg-white p-1 rounded-full text-gray-400 hover:text-gray-500" },
            React.createElement("span", { className: "sr-only" }, "View notifications"),
            React.createElement(SVG, { id: "page_header_notification", size: iconSize, color: iconColor, src: "/icons/platform/notification.svg" }),
            count > 0 &&
                React.createElement("div", { className: "flex flex-row justify-center w-full text-white absolute", style: __assign(__assign({ backgroundColor: countBackgroundColor, width: iconSize * 2 / 3, height: iconSize * 2 / 3 }, styles.countWrapper), countWrapperStyle) },
                    React.createElement("div", { style: __assign(__assign({ color: countColor }, styles.count), countStyle) }, count > 9 ? '9+' : count))));
};
export default IconCount;
